/**
 * Copyright (C) 2007  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.env;

import org.ow2.bonita.persistence.db.DbHistory;
import org.ow2.bonita.util.EnvConstants;
import org.ow2.novabpm.util.Misc;


/**
 * @author Guillaume Porcher
 *
 */
public class DbHistoryEnvGenerator extends EnvGenerator {

  
  
  public DbHistoryEnvGenerator() {
    super();
    StringBuffer hibernateConfigXml = new StringBuffer();
    
    hibernateConfigXml
      .append("<hibernate-configuration name='" + EnvConstants.HISTORY_HB_CONF_NAME + "' >")
      .append(Misc.LINE_SEPARATOR)
      .append(EnvGenerator.INDENT).append("<properties resource='hibernate-history.properties' />")
      .append(Misc.LINE_SEPARATOR)
      .append(EnvGenerator.INDENT).append("<mappings resource='bonita.querier.mappings.hbm.xml' />")
      .append(Misc.LINE_SEPARATOR)
      .append(EnvGenerator.INDENT).append("<mapping resource='bonita.history.stub.hbm.xml' />")
      .append(Misc.LINE_SEPARATOR)
      .append(EnvGenerator.INDENT).append("<cache-configuration resource='bonita.querier.cache.xml' usage='read-write' />")
      .append(Misc.LINE_SEPARATOR)
      .append("</hibernate-configuration>").append(Misc.LINE_SEPARATOR);
    
    setApplicationEntry(EnvConstants.HISTORY_HB_CONF_NAME, hibernateConfigXml.toString());
    
    String hibernateSessionFactory = 
      "<hibernate-session-factory "
      + "name='" + EnvConstants.HISTORY_HB_SESSION_FACTORY_NAME + "' " 
      + "configuration='" + EnvConstants.HISTORY_HB_CONF_NAME + "' />";
    setApplicationEntry(EnvConstants.HISTORY_HB_SESSION_FACTORY_NAME, hibernateSessionFactory);
    
    String hibSession = 
      "<hibernate-session name='" + EnvConstants.HISTORY_HB_SESSION_NAME + "' " 
      + "factory='" + EnvConstants.HISTORY_HB_SESSION_FACTORY_NAME + "' />";
    setBlockEntry(EnvConstants.HISTORY_HB_SESSION_NAME, hibSession);
    
    String hibPersService = 
      "<" + EnvConstants.QUERIER_DB_SESSION_TAG + " " 
      + "name='" + EnvConstants.HISTORY_QUERIER_SESSION_NAME + "' " 
      + "session='" + EnvConstants.HISTORY_HB_SESSION_NAME + "' />";
    setBlockEntry(EnvConstants.HISTORY_QUERIER_SESSION_NAME, hibPersService);
    
    String historyArgs = "<arg><string value='" + EnvConstants.HISTORY_QUERIER_SESSION_NAME + "' /></arg>";
    setHistoryType(DbHistory.class, historyArgs);
  }
}
