package org.ow2.bonita.env.binding;

import org.jbpm.pvm.internal.util.TagBinding;
import org.jbpm.pvm.internal.wire.xml.WireParser;
import org.jbpm.pvm.internal.xml.Parse;
import org.jbpm.pvm.internal.xml.Parser;
import org.ow2.bonita.env.descriptor.RuntimeDbSessionDescriptor;
import org.ow2.bonita.util.EnvConstants;
import org.w3c.dom.Element;

/**
 *
 * @author Marc Blachon, Guillaume Porcher, Charles Souillard, Miguel Valdes, Pierre Vigneras
 */
public class RuntimeDbSessionBinding extends TagBinding {

  public RuntimeDbSessionBinding() {
    super(EnvConstants.RUNTIME_DB_SESSION_TAG, null, WireParser.CATEGORY_DESCRIPTOR);
  }
  
  public Object parse(Element element, Parse parse, Parser parser) {
    RuntimeDbSessionDescriptor descriptor = new RuntimeDbSessionDescriptor();
    
    if (element.hasAttribute("session")) {
      descriptor.setSessionName(element.getAttribute("session"));
    } else {
      throw new RuntimeException("session attribute on " + EnvConstants.RUNTIME_DB_SESSION_TAG + " must be specified");
    }
    
    if (element.hasAttribute("name")) {
      descriptor.setName(element.getAttribute("name"));
    } else {
      throw new RuntimeException("name attribute on " + EnvConstants.RUNTIME_DB_SESSION_TAG + " must be specified");
    }
    return descriptor;
  }

}
